"""
In diesem Modul können eigene Funktionen zur Datenerstellung Generierung integriert werden
Es stehen aufbereitete Rohdaten und die Datenbankverbindung zur Verfügung
Wichtig dabei ist, dass die selbsterstellten Funktionen in der Funktion eigene_wetterdaten
registriert werden, und die Werte in das Dictionary aufbereitete_daten ergänzt werden. Das Keyfeld stellt sogleich
den Namen in der Datenbank dar."""

import messwerte_umrechner as mwu
from weewx_db_model import Archive


def bad(rohdaten):
    datensatz = Archive.get(Archive.date_time == rohdaten["ts"])
    if datensatz.extra_temp1:
        if datensatz.us_units:
            rohdaten["bad_temp"] = mwu.temperaturumrechner(datensatz.extra_temp1)
        else:
            rohdaten["bad_temp"] = datensatz.extra_temp1
    if isinstance(datensatz.extra_humid1, (int, float)):
        rohdaten["bad_feuchte"] = float(round(datensatz.extra_humid1))
    if datensatz.extra_humid1 and datensatz.extra_temp1:
        rohdaten["bad_abs_feuchte"] = mwu.absolute_luftfeuchtigkeit(rohdaten["bad_temp"],
                                                                    rohdaten["bad_feuchte"])
        rohdaten["in_abs_feuchte"] = mwu.absolute_luftfeuchtigkeit(rohdaten["inTemp"],
                                                                   rohdaten["inLuftfeuchte"])
    return rohdaten


def eigene_wetterdaten(rohdaten):
    rohdaten_mit_eigene_daten = bad(rohdaten)
    return rohdaten_mit_eigene_daten
